SystemOrganization addCategory: #'SqSquare-Client'!
SystemOrganization addCategory: #'SqSquare-Client-UI'!
SystemOrganization addCategory: #'SqSquare-Client-AudioChat-UI'!

ElClient subclass: #SqAClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

!SqAClient methodsFor: 'defaults' stamp: 'minami 3/7/2006 15:22'!
audioChatClientClass
	^ Smalltalk at: #SqAudioChatClient! !

CCostume subclass: #SqAudioChatCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqAudioChatCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="controller" toSet="controller:" changeEvent="controllerChanged">controller</field>
	<field toGet="userList" toSet="userList:" changeEvent="userListChanged">userList</field>
</fields>'!

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 12:11'!
controller
	"Answer the controller of the receiver"
	<bewareOf: #controllerChanged>
	^self propertyValueAt: #controller! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 12:11'!
controller: aValue
	"Modify the receiver's controller"
	^self propertyValueAt: #controller put: aValue with: #controllerChanged! !

!SqAudioChatCostume methodsFor: 'initialize' stamp: 'minami 3/7/2006 12:16'!
defaultPlayer
	^ SqAudioChatPlayer! !

!SqAudioChatCostume methodsFor: 'initialize' stamp: 'minami 3/7/2006 17:16'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	self hResizing: #rigid;
		 vResizing: #rigid.
	self layout listDirection: #topToBottom.

	self add: self controller.
	self add: self userList.! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 12:11'!
userList
	"Answer the userList of the receiver"
	<bewareOf: #userListChanged>
	^self propertyValueAt: #userList! !

!SqAudioChatCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 12:11'!
userList: aValue
	"Modify the receiver's userList"
	^self propertyValueAt: #userList put: aValue with: #userListChanged! !

Object subclass: #SqRpcClient
	instanceVariableNames: 'rpcConnector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

SqRpcClient subclass: #SqBoardClient
	instanceVariableNames: 'recordHolder connection isLoggedIn boardDescription authentication accessId eventPlayer eventSender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqBoardClient class methodsFor: 'instance creation' stamp: 'MU 2/10/2006 16:36'!
for: aSqBoardDescription authentication: authentication 
	| inst |
	inst := self new 
				 boardDescription: aSqBoardDescription;
				 authentication: authentication;
				 yourself.
	^ inst! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/25/2006 16:28'!
accessId
	accessId ifNil: [accessId _ SqAccessId 
								userId: self authentication userId
								imageId: SqImageId current
								boardId: self boardDescription boardId].
	^accessId! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:17'!
authentication
	^authentication! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:18'!
authentication: aSqAuthentication 
	authentication := aSqAuthentication! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:24'!
boardDescription
	^ boardDescription! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:25'!
boardDescription: bd 
	boardDescription := bd! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/26/2006 17:53'!
boardId
	^ self accessId boardId! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 2/8/2006 14:38'!
boardName
	^ self boardDescription boardName! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 3/1/2006 10:26'!
closeConnection
	self stopEventSender.
	connection
		ifNotNilDo: [:con | con close].
	connection := nil.
	
	! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:19'!
connection
	connection ifNil: [self ensureConnection].
	^ connection! !

!SqBoardClient methodsFor: 'defaults' stamp: 'MU 1/20/2006 15:19'!
connectionClass
	^ SqExternalConnection! !

!SqBoardClient methodsFor: 'factory' stamp: 'MU 2/8/2006 15:18'!
ensureConnection
	[connection := self connectionClass
				connect: SqSettings serverHost
				to: SqSettings eventListenPort
				returnDo: [:msg | self receiveEvent: msg]
				accessId: self accessId]
		on: RmtNetworkError
		do: [:ex | ex log]! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/29/2006 02:36'!
eventPlayer
	^eventPlayer! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/29/2006 02:36'!
eventPlayer: ep 
	eventPlayer := ep! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:20'!
eventSender
	^eventSender! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:35'!
eventSender: anEventSender
	eventSender _ anEventSender! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 12:28'!
firstEventVersion
	| events |
	events _ self recordHolder events.
	events isEmptyOrNil ifTrue: [^0].
	^events first eventId! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 14:01'!
getAllEvents
	^self rpcGetAllEventsOf: self boardId! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/23/2006 19:01'!
getEventsFrom: startIndex to: endIndex 
	^ [self
		rpcGetEventsOf: self boardId
		from: startIndex
		to: endIndex]
		on: SqOutOfRange
		do: [:ex | ex return: #()]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/23/2006 19:01'!
getLatestEventsFrom: startIndex 
	^ [self rpcGetLatestEventsOf: self boardId from: startIndex] on: SqOutOfRange
		do: [:ex | ex return: #()]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 12:07'!
getLatestSnapshot
	^self rpcGetLatestSnapshotOf: self boardId! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 3/7/2006 14:50'!
getLatestUpdateSeeds
	| latestSnap snapVersion startVersion alreadyHereVersion paddedEvents  |
	self isLoggedIn ifFalse: [^ nil].

	snapVersion := 0.
	latestSnap := self getLatestSnapshot.
	latestSnap notNil
		ifTrue: [snapVersion := latestSnap second asInteger].
	startVersion _ snapVersion + 1.
	alreadyHereVersion := self firstEventVersion.
	paddedEvents := alreadyHereVersion = 0
				ifTrue: [self getLatestEventsFrom: startVersion]
				ifFalse: [self getEventsFrom: startVersion to: alreadyHereVersion - 1].
	^{latestSnap. paddedEvents}! !

!SqBoardClient methodsFor: 'initialize' stamp: 'MU 2/7/2006 18:32'!
initialize
	super initialize.
	recordHolder  _ connection _ nil.

	isLoggedIn _ false.! !

!SqBoardClient methodsFor: 'testing' stamp: 'MU 1/20/2006 15:19'!
isLoggedIn
	^ isLoggedIn == true
! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 1/20/2006 15:19'!
keepConnection
	self isLoggedIn ifTrue: [
		self connection ifNotNilDo: [:con |
			con isValid ifFalse: [self openConnection].
		].
	]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/7/2006 18:47'!
loggedIn
	isLoggedIn _ true! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/7/2006 18:47'!
loggedOut
	isLoggedIn _ true! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 3/1/2006 10:26'!
openConnection
	self closeConnection.
	self ensureConnection.
	self startEventSender.
! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'MU 2/8/2006 15:17'!
receiveEvent: eventRecord
	self recordHolder add: eventRecord! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'mu 3/2/2006 10:49'!
recordEvent: event
	event displayForDebug: 1.
	self eventSender add: event.
	! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:19'!
recordHolder
	recordHolder ifNil: [recordHolder := SqEventRecordHolder new].
	^ recordHolder! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'MU 2/8/2006 11:50'!
registerEventPlayer: aEventPlayer
	self eventPlayer: aEventPlayer.
	self recordHolder addDependent: aEventPlayer.
	! !

!SqBoardClient methodsFor: 'initialize' stamp: 'MU 2/24/2006 11:51'!
release
	super release.
	self closeConnection.
	eventPlayer ifNotNilDo: [:p | p destroy].
	recordHolder ifNotNilDo: [:p | p release].	
	
	eventPlayer _ recordHolder _ connection _ isLoggedIn _ boardDescription _ authentication _ accessId _ nil! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 14:00'!
rpcGetAllEventsOf: boardId
	^self rpcConnector
		invoke: #boardService
		selector: #getAllEventsOf:
		arguments: {boardId}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:34'!
rpcGetEventsOf: boardId from: startIndex to: endIndex
	^self rpcConnector
		invoke: #boardService
		selector: #getEventsOf:from:to:
		arguments: {boardId. startIndex. endIndex}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 16:18'!
rpcGetLatestEventsOf: boardId from: startIndex
	^self rpcConnector
		invoke: #boardService
		selector: #getLatestEventsOf:from:
		arguments: {boardId. startIndex}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:35'!
rpcGetLatestSnapshotOf: boardId
	^self rpcConnector
		invoke: #boardService
		selector: #getLatestSnapshotOf:
		arguments: {boardId}! !

!SqBoardClient methodsFor: 'sending process' stamp: 'MU 3/1/2006 10:35'!
startEventSender
	self stopEventSender.

	self eventSender: (SqEventSender on: self connection).
	self eventSender start.
! !

!SqBoardClient methodsFor: 'sending process' stamp: 'MU 3/1/2006 10:35'!
stopEventSender
	self eventSender ifNotNilDo: [:sender | sender stop].
	self eventSender: nil! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'MU 2/8/2006 11:50'!
unregisterEventPlayer: aEventPlayer
	self recordHolder removeDependent: aEventPlayer! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/27/2006 17:26'!
userId
	^ self accessId userId! !

SqRpcClient subclass: #SqClient
	instanceVariableNames: 'boardClients userId authentication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

SqClient class
	instanceVariableNames: 'clients'!

!SqClient class methodsFor: 'actions' stamp: 'MU 1/24/2006 12:44'!
addClient: client
	self clients add: client.
	^client! !

!SqClient class methodsFor: 'accessing' stamp: 'MU 1/24/2006 13:00'!
clients
	clients
		ifNil: [clients := Set new].
	^ clients! !

!SqClient class methodsFor: 'actions' stamp: 'MU 2/23/2006 18:33'!
closeAll
	self allInstancesDo: [:e | e close].
	clients := nil! !

!SqClient class methodsFor: 'class initialization' stamp: 'MU 2/23/2006 18:33'!
initialize
	"SqClient initialize"
	self closeAll.
	! !

!SqClient class methodsFor: 'utilities' stamp: 'mu 3/2/2006 10:52'!
playAll
	"SqClient playAll"
	self flag: #toBeDeleted.
	SqUIBuilder default playAll! !

!SqClient class methodsFor: 'instance creation' stamp: 'MU 1/24/2006 13:01'!
userId: idStr 
	| inst detected |
	detected _ self clients detect: [:e | e userId = idStr] ifNone: [].
	detected ifNotNil: [^ detected].

	inst _ self new userId: idStr.
	self clients add: inst.
	^ inst! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 13:06'!
authentication
	^ authentication! !

!SqClient methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:31'!
boardAt: boardId
	^ self boards
		detect: [:e | e boardId = boardId]
		ifNone: []! !

!SqClient methodsFor: 'accessing' stamp: 'minami 1/23/2006 13:40'!
boardClientAt: boardId
	^ self boardClients at: boardId ifAbsent: []! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 10:23'!
boardClients
	boardClients ifNil: [boardClients _ Dictionary new].
	^ boardClients! !

!SqClient methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:31'!
boardNamed: boardName 
	^ self boards
		detect: [:e | e boardName = boardName]
		ifNone: []! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 12:29'!
boards
	^ self rpcBoards! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/23/2006 18:32'!
close
	super close.
	self closeConnections! !

!SqClient methodsFor: 'actions' stamp: 'MU 1/20/2006 17:11'!
closeConnections
	self boardClients valuesDo: [:bc |
		bc closeConnection
	].! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 12:26'!
createNewBoard: boardName
	^ self rpcCreateNewBoard: boardName.

! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/8/2006 14:44'!
enterIn: boardDescription
	| boardClient |
	boardClient _ SqBoardClient for: boardDescription authentication: self authentication.
	boardClient openConnection.
	self boardClients at: boardClient boardId put: boardClient.
	
	boardClient loggedIn.

	^boardClient! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:00'!
imageId
	^ SqImageId current! !

!SqClient methodsFor: 'initialize' stamp: 'MU 2/8/2006 11:36'!
initialize
	super initialize.
	boardClients _ nil.
	authentication _ nil! !

!SqClient methodsFor: 'actions' stamp: 'MU 1/20/2006 17:11'!
keepConnections
	self boardClients valuesDo: [:bc | bc keepConnection].! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/8/2006 11:36'!
login: userId password: passStr
	authentication _ self rpcLogin: userId password: passStr.
	^ authentication notNil! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 17:18'!
logout
	authentication ifNil: [^false].
	^self rpcLogout! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/22/2006 12:29'!
rpcBoards
	^self rpcConnector
		invoke: #boardService
		selector: #boards
		arguments: {}! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:34'!
rpcCreateNewBoard: boardName 
	^self rpcConnector
		invoke: #boardService
		selector: #createNewBoard:
		arguments: {boardName}! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/8/2006 11:34'!
rpcLogin: userId password: passStr
	^self rpcConnector
		invoke: #loginService
		selector: #login:password:
		arguments: {userId. passStr}! !

!SqClient methodsFor: 'rpc' stamp: 'MU 2/22/2006 17:14'!
rpcLogout
	^self rpcConnector
		invoke: #loginService
		selector: #logout:
		arguments: {authentication}! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:41'!
userId
	^userId! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:41'!
userId: idStr 
	userId := idStr! !

!SqRpcClient methodsFor: 'actions' stamp: 'MU 2/23/2006 18:30'!
close
	rpcConnector ifNotNilDo: [:con | con close].
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'initialize-release' stamp: 'MU 1/20/2006 15:59'!
initialize
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'printing' stamp: 'MU 2/9/2006 14:41'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	rpcConnector ifNotNilDo: [:con | rpcConnector printOn: aStream].
	aStream nextPutAll: ')'.! !

!SqRpcClient methodsFor: 'initialize-release' stamp: 'MU 2/10/2006 15:31'!
release
	rpcConnector ifNotNilDo: [:con | con closeIfOnlyNotPooled].
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:41'!
rpcConnector
	rpcConnector := RmtRpcConnector pooling connect: SqSettings serverHost port: SqSettings rpcListenPort.
	^ rpcConnector! !

Object subclass: #SqUIBuilder
	instanceVariableNames: 'boards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqUIBuilder class
	instanceVariableNames: 'default'!

!SqUIBuilder class methodsFor: 'instance creation' stamp: 'MU 2/8/2006 11:18'!
default
	default ifNil: [default _ self new].
	^default! !

!SqUIBuilder methodsFor: 'accesing' stamp: 'MU 2/9/2006 15:33'!
boards
	boards ifNil: [boards _ WeakSet new].
	^boards! !

!SqUIBuilder methodsFor: 'builder' stamp: 'minami 2/27/2006 08:52'!
buildBoardFor: boardClient withSeeds: seeds 
	| snapshot events rawBoard |

	snapshot := seeds first.
	events := seeds second.
	rawBoard := snapshot
				ifNil: [SqEventRecordBoard new]
				ifNotNil: [self buildBoardFromSnapshot: snapshot].
	rawBoard boardClient: boardClient.

	rawBoard elements do: [:each | 
		each eventRecordBehavior ifNotNilDo: [:b |
			each detachEventRecordBehavior.
			each playerId: b targetId.
			rawBoard attachEventRecordBehavior: each.
			each eventRecordBehavior board: rawBoard.
			each eventRecordBehavior targetId: b targetId.
		].
	].

	rawBoard eventPlayer addAllFirst: events.

	rawBoard isRecovering: true. 
	rawBoard play.
	events notEmpty ifTrue: [rawBoard eventPlayer waitUntil: #allEventsExecuted].
	rawBoard isRecovering: false.
	
	self boards add: rawBoard.
	^ rawBoard! !

!SqUIBuilder methodsFor: 'builder' stamp: 'MU 2/24/2006 16:40'!
buildBoardFromSnapshot: snapshot
	| board |
	board _ CPlayer readSnapshotByteArray: snapshot last.
	board ifNil: [^nil].
	board isHeadless: false.
	board eventPlayer: nil.
	^board! !

!SqUIBuilder methodsFor: 'initialize-release' stamp: 'MU 2/9/2006 15:33'!
initialize
	boards _ nil! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 2/27/2006 11:10'!
openBoardWindowFor: boardClient
	self openBoardWindowFor: boardClient withMap: false! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 2/27/2006 12:47'!
openBoardWindowFor: boardClient withMap: boolean
	"PRE: boardClient is already connected"

	| board win seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	win := SqBoardWindow on: board.
	win open.
	
	boolean ifTrue: [
		(SqBoardMap for: board) openInHand
	].
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'MU 2/8/2006 14:40'!
openBoardWindow: boardDescription userId: userId 
	"PRE: client has been authenticated"
	| client bc |
	client := SqClient userId: userId.
	client
		ifNil: [^ self].
	bc := client boardClientAt: boardDescription boardId.
	bc
		ifNil: [^ self].
	^ self openBoardWindowFor: bc! !

!SqUIBuilder methodsFor: 'utilities' stamp: 'MU 2/9/2006 15:33'!
playAll
	"just workaround"
	"SqUIBuilder default boards"
	"SqUIBuilder default playAll"

	self boards do: [:each | each play]

	
	! !

!CProjectBuilder class methodsFor: '*SqSquare-Client-notes' stamp: 'mu 3/7/2006 15:16'!
sqSquareReleaseNotes "(Workspace new) contents: self sqSquareReleaseNotes; openLabel: ''"
	^ '- How to start SqSquare -

*On server:
 "Create a default Database"
 SqSquareDB createDb.

 "Start server, create a board"
 SqExample startServer.
 SqExample createBoardOnServer.

*On client:
 SqExample startClientByMenu.
 SqClient playAll. (do it when update stops - it is a known problem)

If you do it, login dialog will open. You can enter ''user01'' from ''user10''. 
(password is the same as userId).

Select ''board1''. You can see two windows. One is a map for the whole screen,
and the other is your local view.

*Settings
To reset board''s contents:
 SqServer forgetAll; deleteAll.
 
To dump on-memory events to DB (shrinking memory usage):
 SqServer dumpAll.

To hide debug messages:
 SqSettings isDebugging: false.
 
To connect from another image:
 SqSetting serverHost: ''<your server>''.

' ! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo-menu' stamp: 'MU 2/17/2006 13:23'!
getLinkForPlayer: target
	target linkForSelf openInHand.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-override' stamp: 'mu 3/2/2006 10:19'!
initialize
	super initialize.
	self allProjects: CCollection new.
	projectShell := self projectShellClass new.
	projectList := self newProjectList.
	self newProject.
	worldMenu := CMenuBar new. "will be clobbered immediately"
	self startScript: #installWorldMenu.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/17/2006 16:21'!
onHaloDrag: aHandle
	| lastPt nextPt delta haloTarget oldPos |
	<on: haloDrag>
	"note: does not recompute transform every frame"
	lastPt := self hand position. "global!!"
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	oldPos := haloTarget position.
	self trackHaloHandle: aHandle in:[
		nextPt := self hand position. "global!!"
		haloTarget container 
			ifNil:[delta := nextPt - lastPt]
			ifNotNil:[delta := (haloTarget container globalToLocal: nextPt) - 
					(haloTarget container globalToLocal: lastPt)].
		haloTarget costume moveBy: delta.
		lastPt := nextPt.
	].
	haloTarget tweaked: #position from: oldPos to: haloTarget position.

	haloTarget signal: #haloDragFinished! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/19/2006 17:01'!
onHaloEvent: aHandle
	| eventName |
	<on: haloEvent in: halo>
	eventName := aHandle value.
	self halo target ifNil:[^self].
	eventName ifNil:[^self].
	self signal: eventName with: aHandle.

	self halo target signal: eventName.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/19/2006 14:37'!
onHaloGrab: aHandle
	| haloTarget parent aHand |
	<on: haloGrab>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	parent := haloTarget container.
	haloTarget transform: haloTarget localToWorld.

	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	parent asPrimCostume tweaked: #contents after:[
		haloTarget world add: haloTarget.
	].
	aHand := aHandle hand.
	halo elements do:[:each| each visible: each == aHandle].
	aHand releaseMouseFocus: aHandle.
	aHandle locked: true.
	haloTarget startScript: #onDrag.
	aHand waitUntil: #mouseUp.
	aHandle locked: false.
	halo elements do:[:each| each visible: true].

	haloTarget signal: #haloGrabFinished
! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'MU 2/13/2006 16:16'!
onHaloLink: aHandle
	"The user has clicked on the hand-me-a-tile halo handle of an object"

	<on: haloLink>
	self getLinkForPlayer: self halo target! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 2/8/2006 01:11'!
onHaloRepaint: aHandle
	| haloTarget painter aForm bForm |
	<on: haloRepaint>
	painter := self makeNewPainter: 32.
	haloTarget := self halo target.
	haloTarget visible: false.
	painter target: haloTarget.
	painter waitUntil: #close.
	projectShell tool: nil.
	haloTarget visible: true.

	aForm := haloTarget graphicForm.
	aForm ifNil: [^ self].

	aForm island == haloTarget island ifFalse:[
		bForm := haloTarget island new: Form 
			constructor: #extent:depth: 
			arguments:{aForm extent. aForm depth}.
		aForm displayOn: bForm.
		haloTarget graphicForm: bForm.
	].
! !

!CProjectBuilder methodsFor: '*SqSquare-Client-initializing' stamp: 'minami 1/20/2006 12:23'!
projectShellClass
	^ CProjectShell! !

!CProjectBuilder methodsFor: '*SqSquare-Client-override' stamp: 'mu 3/2/2006 10:42'!
showInitialStuff
	self waitTick; waitTick.
	self showLicense window moveBy: -10@-40.
	self showReleaseNotes window moveBy: 10@40.

	SqSettings showReleaseNotes ifTrue: [
		self showSqSquareReleaseNotes window moveBy: 40@0.
	]! !

!CProjectBuilder methodsFor: '*SqSquare-Client-initial window' stamp: 'mu 3/2/2006 10:34'!
showSqSquareReleaseNotes
	| ws |
	ws := projectShell myIsland new: CWorkspace.
	"tricky... need to create text in project's island"
	ws contents: (ws send: #sqSquareReleaseNotes to: self class).
	ws extent: 500@400.
	self waitTick.
	ws openCenteredIn: projectShell projectWorld.
	ws label: 'SqSquare'.
	^ws! !

ElAudioChatClient subclass: #SqAudioChatClient
	instanceVariableNames: 'levelIndicator talkButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 15:19'!
levelIndicator
	^ levelIndicator! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 15:19'!
levelIndicator: aPlayer
	levelIndicator := aPlayer! !

!SqAudioChatClient methodsFor: 'action common' stamp: 'minami 3/7/2006 16:37'!
startSpeaking
	talkButton
		ifNotNilDo: [:button | button color: Color red].
	super startSpeaking! !

!SqAudioChatClient methodsFor: 'running' stamp: 'minami 3/7/2006 16:39'!
stop
	super stop.
	talkButton
		ifNotNilDo: [:button | button color: Color gray].! !

!SqAudioChatClient methodsFor: 'action common' stamp: 'minami 3/7/2006 16:37'!
stopSpeaking
	super stopSpeaking.
	talkButton
		ifNotNilDo: [:button | button color: Color gray].! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:36'!
talkButton
	^ talkButton! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:36'!
talkButton: aButton
	talkButton := aButton! !

!SqAudioChatClient methodsFor: 'private ui' stamp: 'minami 3/7/2006 15:31'!
uiUpdateLevel: anInteger
	levelIndicator ifNil: [^ self].
	levelIndicator level: (anInteger / 16r8000) asFloat! !

CPlayer subclass: #SqAudioChatClientPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqAudioChatClientPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="chatClient" toSet="chatClient:" changeEvent="chatClientChanged">chatClient</field>
	<field toGet="levelIndicator" toSet="levelIndicator:" changeEvent="levelIndicatorChanged">levelIndicator</field>
	<field toGet="chatButton" toSet="chatButton:" changeEvent="chatButtonChanged">chatButton</field>
</fields>'!

!SqAudioChatClientPlayer class methodsFor: 'instance creation' stamp: 'minami 3/7/2006 11:37'!
on: audioChatClient 
	^ self basicNew chatClient: audioChatClient;
		 initialize;
		 yourself! !

!SqAudioChatClientPlayer methodsFor: 'accessing' stamp: 'minami 3/2/2006 16:56'!
chatButton
	"Answer the chatButton of the receiver"
	<bewareOf: #chatButtonChanged>
	^self propertyValueAt: #chatButton! !

!SqAudioChatClientPlayer methodsFor: 'accessing' stamp: 'minami 3/2/2006 16:56'!
chatButton: aValue
	"Modify the receiver's chatButton"
	^self propertyValueAt: #chatButton put: aValue with: #chatButtonChanged! !

!SqAudioChatClientPlayer methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:37'!
chatClient
	"Answer the chatClient of the receiver"
	<bewareOf: #chatClientChanged>
	^self propertyValueAt: #chatClient! !

!SqAudioChatClientPlayer methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:37'!
chatClient: aValue
	"Modify the receiver's chatClient"
	^self propertyValueAt: #chatClient put: aValue with: #chatClientChanged! !

!SqAudioChatClientPlayer methodsFor: 'initialize' stamp: 'minami 3/2/2006 16:54'!
initialize
	super initialize.! !

!SqAudioChatClientPlayer methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:35'!
levelIndicator
	"Answer the levelIndicator of the receiver"
	<bewareOf: #levelIndicatorChanged>
	^self propertyValueAt: #levelIndicator! !

!SqAudioChatClientPlayer methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:35'!
levelIndicator: aValue
	"Modify the receiver's levelIndicator"
	^self propertyValueAt: #levelIndicator put: aValue with: #levelIndicatorChanged! !

!SqAudioChatClientPlayer methodsFor: 'initialize' stamp: 'minami 3/7/2006 11:38'!
setupCostume
	super setupCostume.

	chatButton := SqAudioChatToggleButton on: self chatClient.
	self add: chatButton.

	levelIndicator := SqLevelIndicator new.
	self add: levelIndicator.! !

CPlayer subclass: #SqAudioChatController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqAudioChatController defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="startButton" toSet="startButton:" changeEvent="startButtonChanged">startButton</field>
	<field toGet="talkButton" toSet="talkButton:" changeEvent="talkButtonChanged">talkButton</field>
	<field toGet="levelIndicator" toSet="levelIndicator:" changeEvent="levelIndicatorChanged">levelIndicator</field>
	<field toGet="client" toSet="client:" changeEvent="clientChanged">client</field>
</fields>'!

!SqAudioChatController class methodsFor: 'instance creation' stamp: 'minami 3/7/2006 16:25'!
client: client
	^ self new client: client; yourself! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 3/7/2006 14:01'!
addSpacer: spacerExtent
	^ self addSpacer: spacerExtent color: Color transparent! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 3/7/2006 14:01'!
addSpacer: spacerExtent color: spacerColor
	| aSpacer |
	aSpacer := CPlayer new.
	aSpacer borderWidth: 0.
	aSpacer extent: spacerExtent.
	aSpacer color: spacerColor.
	self add: aSpacer.
	^ aSpacer
	! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 3/7/2006 15:38'!
chatClient
	self client ifNil: [^ nil].

	^ self client chatClient! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:55'!
client
	"Answer the client of the receiver"
	<bewareOf: #clientChanged>
	^self propertyValueAt: #client! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:55'!
client: aValue
	"Modify the receiver's client"
	^self propertyValueAt: #client put: aValue with: #clientChanged! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 3/7/2006 15:38'!
commandClient
	self client ifNil: [^ nil].

	^ self client commandClient! !

!SqAudioChatController methodsFor: 'initialize' stamp: 'minami 3/7/2006 13:49'!
initialize
	super initialize! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
levelIndicator
	"Answer the levelIndicator of the receiver"
	<bewareOf: #levelIndicatorChanged>
	^self propertyValueAt: #levelIndicator! !

!SqAudioChatController methodsFor: 'defaults' stamp: 'minami 3/7/2006 13:56'!
levelIndicatorExtent
	^ 96@24! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
levelIndicator: aValue
	"Modify the receiver's levelIndicator"
	^self propertyValueAt: #levelIndicator put: aValue with: #levelIndicatorChanged! !

!SqAudioChatController methodsFor: 'events' stamp: 'minami 3/7/2006 16:28'!
onClientRunningStateChanged: bool
	<on: isRunningChanged in: client>

	self startButton label: self startButtonLabel.

	bool ifFalse: [self levelIndicator reset].! !

!SqAudioChatController methodsFor: 'events' stamp: 'minami 3/7/2006 15:04'!
onStartButtonFired
	<on: fire in: startButton>

	^ client isRunning
		ifTrue: [client stop]
		ifFalse: [client start]! !

!SqAudioChatController methodsFor: 'events' stamp: 'minami 3/7/2006 16:30'!
onTalkButtonFired
	<on: fire in: talkButton>

	client ifNil: [ ^ self ].

	client chatClient ifNotNilDo: [:cc |
		cc isSpeaking 
			ifTrue: [cc stopSpeaking.
					self levelIndicator reset] 
			ifFalse: [cc sendWantsToSpeakCommand].
	].
! !

!SqAudioChatController methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:40'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.

">>>> for debug"
	self startButton: CButton new.
	self startButton extent: self talkButtonExtent.
	self add: self startButton.
	self startButton label: self startButtonLabel.
	self addSpacer: self spacerExtent.
"<<<< for debug"

	self talkButton: CButton new.
	self talkButton extent: self talkButtonExtent.
	self talkButton color: Color gray.
	self add: self talkButton.
	self chatClient ifNotNilDo: [:cc | cc talkButton: self talkButton].

	self addSpacer: self spacerExtent.

	self levelIndicator: SqLevelIndicator new.
	self levelIndicator extent: self levelIndicatorExtent.
	self add: self levelIndicator.
	self chatClient ifNotNilDo: [:cc | cc levelIndicator: self levelIndicator].! !

!SqAudioChatController methodsFor: 'defaults' stamp: 'minami 3/7/2006 14:07'!
spacerExtent
	^ 3@24! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:30'!
startButton
	"Answer the startButton of the receiver"
	<bewareOf: #startButtonChanged>
	^self propertyValueAt: #startButton! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 3/7/2006 14:55'!
startButtonLabel
	client ifNil: [^ 'Start'].
	
	^ client isRunning
		ifTrue: ['Stop']
		ifFalse: ['Start']! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:30'!
startButton: aValue
	"Modify the receiver's startButton"
	^self propertyValueAt: #startButton put: aValue with: #startButtonChanged! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
talkButton
	"Answer the talkButton of the receiver"
	<bewareOf: #talkButtonChanged>
	^self propertyValueAt: #talkButton! !

!SqAudioChatController methodsFor: 'defaults' stamp: 'minami 3/7/2006 13:56'!
talkButtonExtent
	^ 48@24! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
talkButton: aValue
	"Modify the receiver's talkButton"
	^self propertyValueAt: #talkButton put: aValue with: #talkButtonChanged! !

CPlayer subclass: #SqAudioChatUserList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqAudioChatUserList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqAudioChatUserList methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:42'!
initialize
	super initialize! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/7/2006 17:14'!
removeId: id
	| detected |
	detected := self costume contents detect: [:tile | tile id = id] ifNone: [].
	detected ifNotNil: [self remove: detected].
	! !

!SqAudioChatUserList methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:42'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.
! !

CPlayer subclass: #SqAudioChatUserPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqAudioChatUserPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

CPlayer subclass: #SqAudioChatUserTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqAudioChatUserTile defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="id" toSet="id:" changeEvent="idChanged">id</field>
	<field toGet="nickname" toSet="nickname:" changeEvent="nicknameChanged">nickname</field>
	<field toGet="speakingLamp" toSet="speakingLamp:" changeEvent="speakingLampChanged">speakingLamp</field>
	<field toGet="listeningLamp" toSet="listeningLamp:" changeEvent="listeningLampChanged">listeningLamp</field>
	<field toGet="nameLabel" toSet="nameLabel:" changeEvent="nameLabelChanged">nameLabel</field>
</fields>'!

!SqAudioChatUserTile class methodsFor: 'instance creation' stamp: 'minami 3/7/2006 17:02'!
id: id nickname: nickname 
	^ self new id: id;
		 nickname: nickname;
		 yourself! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:54'!
addSpacer: spacerExtent
	^ self addSpacer: spacerExtent color: Color transparent! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:54'!
addSpacer: spacerExtent color: spacerColor
	| aSpacer |
	aSpacer := CPlayer new.
	aSpacer borderWidth: 0.
	aSpacer extent: spacerExtent.
	aSpacer color: spacerColor.
	self add: aSpacer.
	^ aSpacer
	! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:51'!
createNewLamp
	^ CPlayer new color: Color lightGray;
		 extent: 8 @ 8;
		 yourself! !

!SqAudioChatUserTile methodsFor: 'defaults' stamp: 'minami 3/7/2006 16:59'!
defaultBackgroundColor
	^ Color white darker! !

!SqAudioChatUserTile methodsFor: 'defaults' stamp: 'minami 3/7/2006 16:58'!
defaultExtent
	^ 120@16! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
id
	"Answer the id of the receiver"
	<bewareOf: #idChanged>
	^self propertyValueAt: #id! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
id: aValue
	"Modify the receiver's id"
	^self propertyValueAt: #id put: aValue with: #idChanged! !

!SqAudioChatUserTile methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:46'!
initialize
	super initialize! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
listeningLamp
	"Answer the listeningLamp of the receiver"
	<bewareOf: #listeningLampChanged>
	^self propertyValueAt: #listeningLamp! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
listeningLamp: aValue
	"Modify the receiver's listeningLamp"
	^self propertyValueAt: #listeningLamp put: aValue with: #listeningLampChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:52'!
nameLabel
	"Answer the nameLabel of the receiver"
	<bewareOf: #nameLabelChanged>
	^self propertyValueAt: #nameLabel! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:52'!
nameLabel: aValue
	"Modify the receiver's nameLabel"
	^self propertyValueAt: #nameLabel put: aValue with: #nameLabelChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
nickname
	"Answer the nickname of the receiver"
	<bewareOf: #nicknameChanged>
	^self propertyValueAt: #nickname! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
nickname: aValue
	"Modify the receiver's nickname"
	^self propertyValueAt: #nickname put: aValue with: #nicknameChanged! !

!SqAudioChatUserTile methodsFor: 'initialize' stamp: 'minami 3/7/2006 17:04'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.

	self extent: self defaultExtent.
	self color: self defaultBackgroundColor.

	self listeningLamp: self createNewLamp.
	self add: self listeningLamp.

	self addSpacer: 2@8.

	self speakingLamp: self createNewLamp.
	self add: self speakingLamp.

	self addSpacer: 2@8.

	self nameLabel: (CLabel new label: self nickname; yourself).
	self add: self nameLabel.
! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
speakingLamp
	"Answer the speakingLamp of the receiver"
	<bewareOf: #speakingLampChanged>
	^self propertyValueAt: #speakingLamp! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
speakingLamp: aValue
	"Modify the receiver's speakingLamp"
	^self propertyValueAt: #speakingLamp put: aValue with: #speakingLampChanged! !

CPlayer subclass: #SqLevelIndicator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat-UI'!

SqLevelIndicator defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="level" toSet="level:" changeEvent="levelChanged">level</field>
	<field toGet="backgroundColor" toSet="backgroundColor:" changeEvent="backgroundColorChanged">backgroundColor</field>
</fields>'!

!SqLevelIndicator class methodsFor: 'examples' stamp: 'minami 3/7/2006 11:50'!
ex01
"
SqLevelIndicator ex01
"
	| indicator |
	indicator := SqLevelIndicator openInHand.
	0 to: 1 by: 0.02 do: [:i |
		indicator level: i.
		indicator waitTick.
	].

	1 to: 0 by: -0.02 do: [:i |
		indicator level: i.
		indicator waitTick.
	].! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:42'!
backgroundColor
	"Answer the backgroundColor of the receiver"
	<bewareOf: #backgroundColorChanged>
	^self propertyValueAt: #backgroundColor! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:42'!
backgroundColor: aValue
	"Modify the receiver's backgroundColor"
	^self propertyValueAt: #backgroundColor put: aValue with: #backgroundColorChanged! !

!SqLevelIndicator methodsFor: 'drawing' stamp: 'minami 3/7/2006 11:46'!
drawOn: aCanvas in: drawingBounds
	| bw w x r |
	bw := self borderWidth.
	aCanvas
		frameAndFillRectangle: drawingBounds 
		fillColor: self color 
		borderWidth: bw 
		borderColor: self borderColor.

	w := ((drawingBounds width - (bw * 2)) * (((1 - level) min: 1) max: 0)) asInteger.
	x := drawingBounds topRight x - w.
	r := x @ (drawingBounds topLeft y + bw) corner: drawingBounds bottomRight - bw.

	aCanvas fillRectangle: r color: self backgroundColor! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/7/2006 12:18'!
initialize
	super initialize.
	self userDraw: true.
	
	level := 0.
	
	self borderWidth: 2.
	self borderColor: Color black.
	self color: Color yellow.
	self backgroundColor: Color lightGray.

! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:04'!
level
	"Answer the level of the receiver"
	<bewareOf: #levelChanged>
	^self propertyValueAt: #level! !

!SqLevelIndicator methodsFor: 'accessing' stamp: 'minami 3/7/2006 11:04'!
level: aValue
	"Modify the receiver's level"
	^self propertyValueAt: #level put: aValue with: #levelChanged! !

!SqLevelIndicator methodsFor: 'events' stamp: 'minami 3/7/2006 11:12'!
onLevelChanged
	<on: levelChanged>

	self invalidate! !

!SqLevelIndicator methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:28'!
reset
	self level: 0! !

ApplicationService subclass: #SqEventSender
	instanceVariableNames: 'connection eventQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqEventSender class methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:23'!
defaultPriority

	^Processor lowIOPriority! !

!SqEventSender class methodsFor: 'instance creation' stamp: 'minami 2/28/2006 15:58'!
on: aConnection
	^ self new connection: aConnection; yourself! !

!SqEventSender methodsFor: 'adding' stamp: 'minami 2/28/2006 16:39'!
add: aEvent
	self eventQueue nextPut: aEvent! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 15:59'!
connection
	^ connection! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 15:59'!
connection: aConnection
	connection := aConnection! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 16:36'!
eventQueue
	^ eventQueue! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 17:12'!
initialize
	super initialize.

	eventQueue := SharedQueue2 new: 100.

	! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 17:12'!
release
	eventQueue ifNotNilDo: [:q | q release].! !

!SqEventSender methodsFor: 'running' stamp: 'minami 2/28/2006 16:03'!
runWhile: aBlock
	[aBlock value and:[self connection isValid]] 
		whileTrue: [self send]! !

!SqEventSender methodsFor: 'actions' stamp: 'mu 3/7/2006 17:13'!
send
	| event |
	event := self eventQueue next.
	event ifNil: [^self].
	self connection send: event.! !

!SqEventSender methodsFor: 'running' stamp: 'MU 3/1/2006 10:34'!
stop
	super stop.
	self release! !
SqClient initialize!
